%define inst_xinput alternatives --install %{_sysconfdir}/X11/xinit/xinputrc xinputrc %{_sysconfdir}/X11/xinit/xinput.d/uim.conf 50
%define uninst_xinput alternatives --remove xinputrc %{_sysconfdir}/X11/xinit/xinput.d/uim.conf

Name:		uim
Version:	1.3.0
Release:	1%{?dist}
License:	GPL/BSD
URL:		http://uim.freedesktop.org/
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	libXft-devel libX11-devel libXext-devel libXrender-devel libXau-devel libXdmcp-devel libXt-devel
BuildRequires:	gtk2-devel gnome-panel-devel qt-devel ncurses-devel
BuildRequires:	anthy-devel Canna-devel m17n-lib-devel
BuildRequires:	emacs
Source0:	http://uim.freedesktop.org/release/%{name}-%{version}.tar.bz2
Source1:	xinput.d-uim
Source2:	uim-init.el


Summary:	A multilingual input method library
Group:		System Environment/Libraries
Requires(post): %{_sbindir}/alternatives /sbin/ldconfig
Requires(postun): %{_sbindir}/alternatives /sbin/ldconfig
Requires:	xorg-x11-xinit >= 1.0.2-5.fc6

%package	devel
Summary:	Development files for the Uim library
Group:		Development/Libraries
Requires:	uim = %{version}-%{release}

%package	gtk2
Summary:	GTK+2 support for Uim
Group:		User Interface/Desktops
Requires:	uim = %{version}-%{release}
Requires(post):	gtk2
Requires(postun): gtk2
# for update-gtk-immodules
PreReq:		gtk2 >= 2.9.1-2

%package	gnome
Summary:	GNOME Applet for Uim
Group:		User Interface/Desktops
Requires:	uim = %{version}-%{release}
Requires(post):	%{_sbindir}/bonobo-activation-sysconf
Requires(postun): %{_sbindir}/bonobo-activation-sysconf

%package	qt
Summary:	Qt support for Uim
Group:		User Interface/Desktops
Requires:	uim = %{version}-%{release}

%package	el
Summary:	Emacs support for Uim
Group:		System Environment/Libraries
Requires:	%{name}-el-common = %{version}
Requires:	emacs-common

%package	el-common
Summary:	Common package for Emacsen support for Uim
Group:		System Environment/Libraries
Requires:	uim = %{version}-%{release}

%package	anthy
Summary:	Anthy support for Uim
Group:		System Environment/Libraries
Requires:	anthy
Requires:	uim = %{version}-%{release}
Requires(post):	gtk2
Requires(postun): gtk2

%package	canna
Summary:	Canna support for Uim
Group:		System Environment/Libraries
Requires:	Canna
Requires:	uim = %{version}-%{release}
Requires(post):	gtk2
Requires(postun): gtk2

%package	skk
Summary:	SKK support for Uim
Group:		System Environment/Libraries
Requires:	skkdic
Requires:	uim = %{version}-%{release}
Requires(post):	gtk2
Requires(postun): gtk2

%package	m17n
Summary:	m17n-lib support for Uim
Group:		System Environment/Libraries
Requires:	uim = %{version}-%{release}
Requires(post):	gtk2
Requires(postun): gtk2

%description
Uim is a multilingual input method library. Uim aims to
provide secure and useful input methods for all
languages. Currently, it can input to applications which
support Gtk+'s immodule, Qt's immodule and XIM.

This package provides the input method library, the XIM
bridge and most of the input methods.

For the Japanese input methods you need to install
- uim-anthy for Anthy
- uim-canna for Canna
- uim-skk for SKK.

%description	devel
Uim is a multilingual input method library. Uim aims to
provide secure and useful input methods for all
languages.

This package contains the header files and the libraries which is
needed for developing Uim applications.

%description	gtk2
Uim is a multilingual input method library. Uim aims to
provide secure and useful input methods for all
languages.

This package provides the Gtk IM module and helper program.

%description	gnome
Uim is a multilingual input method library. Uim aims to
provide secure and useful input methods for all
languages.

This package provides the GNOME panel applet.

%description	qt
Uim is a multilingual input method library. Uim aims to
provide secure and useful input methods for all
languages.

This package provides the Qt IM module and helper programs.

%description	el
This package provides Emacs support.

%description	el-common
This package provides an utility to use Emacsen support for Uim.

%description	anthy
This package provides support for Anthy, a Japanese input method.

%description	canna
This package provides support for Canna, a Japanese input method.

%description	skk
This package provides support for SKK, a Japanese input method.

%description	m17n
This package provides support for m17n-lib, which allows input of
many languages using the input table map from m17n-db.


%prep
%setup -q -n %{name}-%{version}


%build
# assumes that this is built against qt-3.3.
export QTDIR=%{_libdir}/qt-3.3
%configure --with-x --with-xft --with-canna --with-anthy --with-m17nlib --without-scim --with-gtk2 --with-gnome2 --with-qt --with-qt-immodule
make

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT

rm -rf $RPM_BUILD_ROOT%{_libdir}/uim/plugin/*la

install -d $RPM_BUILD_ROOT%{_sysconfdir}/X11/xinit/xinput.d
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/X11/xinit/xinput.d/uim.conf
install -d $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp/site-start.d
install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp/site-start.d/

%find_lang %{name}
%find_lang uim-chardict-qt

find $RPM_BUILD_ROOT -name "*.scm" -type f | egrep -v "(anthy|canna|skk|m17n)" > scm.list
cat scm.list | sed -e s,$RPM_BUILD_ROOT,,g >> %{name}.lang

# compress large doc
bzip2 ChangeLog

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
%{inst_xinput}

%postun
/sbin/ldconfig
if [ "$1" = "0" ]; then
	%{uninst_xinput}
fi

%post gtk2
umask 022
%{_bindir}/update-gtk-immodules %{_host} || :

%postun gtk2
umask 022
%{_bindir}/update-gtk-immodules %{_host} || :

%post gnome
bonobo-activation-sysconf --add-directory=%{_libdir}/bonobo/servers > /dev/null

%postun gnome
if [ "$1" = "0" ]; then
	bonobo-activation-sysconf --remove-directory=%{_libdir}/bonobo/servers
fi


%files -f %{name}.lang
%defattr (-, root, root)
%doc AUTHORS COPYING ChangeLog* NEWS README
%{_bindir}/uim-fep*
%{_bindir}/uim-module-manager
%{_bindir}/uim-sh
%{_bindir}/uim-xim
%{_libdir}/lib*.so.*
%dir %{_datadir}/uim
%{_sysconfdir}/X11/xinit/xinput.d
%dir %{_libdir}/uim
%{_libdir}/uim/plugin/libuim-custom-enabler.so
%{_libexecdir}/uim-helper-server
%{_datadir}/uim/pixmaps
%{_datadir}/uim/helperdata
%{_mandir}/man1/uim-xim.1*

%files	devel
%defattr (-, root, root)
%dir %{_datadir}/uim
%{_includedir}/uim/
%{_libdir}/gtk-2.0/2.*/immodules/im-uim.*a
%{_libdir}/lib*.la
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*

%files	gtk2
%defattr (-, root, root)
%{_bindir}/uim-toolbar-gtk
%{_bindir}/uim-toolbar-gtk-systray
%{_bindir}/uim-pref-gtk
%{_bindir}/uim-im-switcher-gtk
%{_bindir}/uim-input-pad-ja
%{_libdir}/gtk-2.0/2.*/immodules
%{_libexecdir}/uim-candwin-gtk
%exclude %{_libdir}/gtk-2.0/2.*/immodules/im-uim.*a
%dir %{_datadir}/uim
%{_datadir}/applications/uim.desktop

%files	gnome
%defattr (-, root, root)
%{_libexecdir}/uim-toolbar-applet
%{_libdir}/bonobo/servers/GNOME_UimApplet.server

%files	-f uim-chardict-qt.lang qt
%defattr (-, root, root)
%{_bindir}/uim-chardict-qt
%{_bindir}/uim-im-switcher-qt
%{_bindir}/uim-pref-qt
%{_bindir}/uim-toolbar-qt
%{_libdir}/qt-3.*/plugins/inputmethods
%{_libexecdir}/uim-candwin-qt
%exclude %{_libdir}/qt-3.*/plugins/inputmethods/lib*.*a

%files	el
%defattr (-, root, root)
%doc emacs/COPYING emacs/README
%lang(ja) %doc emacs/README.ja
%{_datadir}/emacs/site-lisp/uim-el
%{_datadir}/emacs/site-lisp/site-start.d/uim-init.el

%files el-common
%defattr (-, root, root)
%{_bindir}/uim-el-agent
%{_bindir}/uim-el-helper-agent

%files	anthy
%defattr (-, root, root)
%{_libdir}/uim/plugin/libuim-anthy.so
%dir %{_datadir}/uim
%{_datadir}/uim/anthy*.scm

%files	canna
%defattr (-, root, root)
%{_libdir}/uim/plugin/libuim-canna.so
%dir %{_datadir}/uim
%{_datadir}/uim/canna*.scm

%files	skk
%defattr (-, root, root)
%{_libdir}/uim/plugin/libuim-skk.so
%dir %{_datadir}/uim
%{_datadir}/uim/skk*.scm

%files m17n
%defattr (-, root, root)
%{_libdir}/uim/plugin/libuim-m17nlib.so
%dir %{_datadir}/uim
%{_datadir}/uim/m17nlib.scm

%changelog
* Mon Dec 18 2006 Akira TAGOH <tagoh@redhat.com> - 1.3.0-1
- New upstream release.

* Fri Sep 15 2006 Akira TAGOH <tagoh@redhat.com> - 1.2.1-2
- rebuilt

* Fri Sep  1 2006 Akira TAGOH <tagoh@redhat.com> - 1.2.1-1
- New upstream release.

* Fri Aug  4 2006 Akira TAGOH <tagoh@redhat.com> - 1.2.0-1
- New upstream release.

* Mon Jul 24 2006 Akira TAGOH <tagoh@redhat.com> - 1.1.1-2
- install a xinput file with .conf suffix.

* Fri Jul  7 2006 Akira TAGOH <tagoh@redhat.com> - 1.1.1-1
- New upstream release.

* Wed Jul  5 2006 Akira TAGOH <tagoh@redhat.com> - 1.1.0-2
- use %%{_host} not %%{_target_platform} for update-gtk-immodules.
- add PreReq: gtk2 >= 2.9.1-2 and ignore update-gtk-immodules errors.
- follow the new xinput.sh and added Requires: xorg-x11-xinit >= 1.0.2-5.fc6.
- removed the unnecessary %%post and %%postun.

* Mon Jun 19 2006 Akira TAGOH <tagoh@redhat.com> - 1.1.0-1
- New upstream release.

* Thu Mar  2 2006 Akira TAGOH <tagoh@redhat.com> - 1.0.1-2
- rebuilt.

* Tue Dec 27 2005 Akira TAGOH <tagoh@redhat.com> - 1.0.1-1
- New upstream release.

* Fri Dec 16 2005 Akira TAGOH <tagoh@redhat.com> - 1.0.0-0.2.beta
- updates to 1.0.0-beta.

* Thu Dec 15 2005 Akira TAGOH <tagoh@redhat.com> - 1.0.0-0.1.alpha
- New upstream release.
- added uim-m17n package. (#175600)
- added uim-el package.
- uim-0.4.6-dont-require-devel-pkgs.patch: removed.

* Fri Sep 30 2005 Akira TAGOH <tagoh@redhat.com> - 0.4.9.1-1
- New upstream release.

* Wed Aug 17 2005 Akira TAGOH <tagoh@redhat.com> - 0.4.8-1
- New upstream release.

* Thu Aug  4 2005 Akira TAGOH <tagoh@redhat.com> - 0.4.7.1-2
- removed Requires: Canna-devel from uim-canna. this is no longer needed
  since 0.4.6-4. (Warren Togami, #165088)

* Wed Aug  3 2005 Akira TAGOH <tagoh@redhat.com> - 0.4.7.1-1
- New upstream release.

* Tue Jul 12 2005 Akira TAGOH <tagoh@redhat.com> - 0.4.7-1
- New upstream release.
- removed the patches. fixed in upstream.
  - uim-0.4.6-multilib.patch
  - uim-0.4.6-fix-typo-in-configure.patch

* Wed Jun 29 2005 Akira TAGOH <tagoh@redhat.com> - 0.4.6-5
- built with --without-scim explicitly. it doesn't work actually.

* Mon Jun 13 2005 Akira TAGOH <tagoh@redhat.com> - 0.4.6-4
- uim-0.4.6-fix-typo-in-configure.patch: applied to get uim-pref-gtk building.
- uim-0.4.6-dont-require-devel-pkgs.patch: applied to be able to dlopen
  the shared libraries without -devel packages.

* Mon May 16 2005 Akira TAGOH <tagoh@redhat.com> - 0.4.6-3
- uim-0.4.6-multilib.patch: applied to fix a build issue for
  libquiminputcontextplugin.so. (John Thacker, #156880)

* Fri May  6 2005 Akira TAGOH <tagoh@redhat.com> - 0.4.6-2
- added BuildRequires: ncurses-devel. (#156880)

* Mon Apr 18 2005 Akira TAGOH <tagoh@redhat.com> - 0.4.6-1
- New upstream release. (#155173)
  - fixed missing return statement issue. (#150304)
- Updated upstream URL.
- ensure to build with Canna and anthy.
- enabled Qt immodule.
- added QT_IM_MODULE=uim to xinput.d-uim

* Fri Apr  1 2005 Michael Schwendt <mschwendt[AT]users.sf.net> - 0.4.5.1-2
- Include headers directory in -devel package.

* Fri Mar  4 2005 Ville Skyttä <ville.skytta at iki.fi>
- Split context marked dependency syntax to work around #118773.
- Add ldconfig scriptlet dependencies.

* Thu Feb 24 2005 Akira TAGOH <tagoh@redhat.com> - 0.4.5.1-1
- New upstream release.
  - security fix.
- support xinput script.

* Sun Feb 20 2005 Thorsten Leemhuis <fedora[AT]leemhuis[dot]info> 0.4.5-2
- Added autoreconf-patch; fixes build on x86_64

* Wed Jan 12 2005 Akira TAGOH <tagoh@redhat.com> 0.4.5-1
- New upstream release.

* Wed Sep 08 2004 Akira TAGOH <tagoh@redhat.com> 0.4.3-1
- New upstream release.
- moved out gtk2 related files to uim-gtk2 package.

* Mon Jul 12 2004 Jens Petersen <petersen@redhat.com> - 0.4.0-1
- no longer need to remove screen files
- include console fep programs

* Fri Jul  2 2004 Jens Petersen <petersen@redhat.com> - 0.3.9-3
- support both update-gtk-immodules of newer gtk2 and older
  gtk-query-immodules-2.0 with new %%gtk_im_update added

* Wed Jun 30 2004 Jens Petersen <petersen@redhat.com> - 0.3.9-2
- add uim-applet-category-cjk.patch to put applet in right submenu
- improve the summaries and descriptions
- make the Requires(postun) be Requires(post,postun)
- file ownership and other minor cleanup

* Wed Jun 23 2004 Akira TAGOH <tagoh@redhat.com> 0.3.9-1
- New upstream release.

* Fri Jun 04 2004 Akira TAGOH <tagoh@redhat.com> 0.3.8-4
- wrote the descriptions.
- uim-skk: fixed the dependency.

* Fri Jun 04 2004 Nils Philippsen <nphilipp@redhat.com> 0.3.8-3
- more spec cleanups

* Fri Jun 04 2004 Warren Togami <wtogami@redhat.com> 0.3.8-2
- many spec cleanups

* Thu Jun 03 2004 Akira TAGOH <tagoh@redhat.com> 0.3.8-1
- Initial package.
